/* wydawca - automatic release submission daemon
   Copyright (C) 2009, 2010, 2011, 2012, 2013, 2017, 2019 Sergey
   Poznyakoff

   Wydawca is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3 of the License, or (at your
   option) any later version.

   Wydawca is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with wydawca. If not, see <http://www.gnu.org/licenses/>. */

#include "wydawca.h"

static struct grecs_txtacc *report_acc;
char *report_string;

void
report_init()
{
	if (!report_acc)
		report_acc = grecs_txtacc_create();
	else
		grecs_txtacc_free_string(report_acc, report_string);
}

void
report_add(const char *fmt, ...)
{
	va_list ap;
	char *str = NULL;
	size_t size = 0;

	va_start(ap, fmt);
	grecs_vasprintf(&str, &size, fmt, ap);
	va_end(ap);
	if (str) {
		grecs_txtacc_grow_string(report_acc, str);
		grecs_txtacc_grow_char(report_acc, '\n');
	}
	free(str);
}

void
report_finish()
{
	grecs_txtacc_grow_char(report_acc, 0);
	report_string = grecs_txtacc_finish(report_acc, 0);
}
